// unit test function 
function MadxBridge_Test()
{
	MadxBridge_AdjustMargin(0);
	MadxBridge_DisableTouch();
	
	result = MadxBridge_Loaded();
	
	if ( MadxBridge_OK(result) != true )
	{
    alert ("MadxBridge_Loaded() should have succeeded");
	}
  
	result = MadxBridge_EnumerateImages();
  
	if (MadxBridge_FAIL(result))
	{
    alert ("should have succeeded");
	}
	
	result = MadxBridge_ShouldShowAd();
	if (MadxBridge_OK(result) == false)
	{
    alert ("should have succeeded");
	}
	
	result = MadxBridge_ShouldShowAd();
	if (MadxBridge_FAIL(result)==true)
	{
    alert ("should have succeeded");
	}
}

function MadxBridge_ReturnResultWithData(result, data)
{
	var returnResult = {};
	returnResult.success = result ? "OK" : "FAIL";
	returnResult.data = data;
	return JSON.stringify(returnResult);
}

function MadxBridge_ReturnResult(result)
{
	var returnResult = {};
	returnResult.success = result ? "OK" : "FAIL";
	return JSON.stringify(returnResult);
}

function MadxBridge_OK(result)
{
	var temp = JSON.parse(result);
	
	if (temp == undefined)
		return false;
  
	if (typeof temp.success == 'undefined')
    return false;
	
	return (temp.success=="OK");
}

function MadxBridge_FAIL(result)
{
	var temp = JSON.parse(result);
  
	if (temp == undefined)
		return true;
  
	if (typeof temp.success == 'undefined')
    return true;
  
	return (temp.success=="FAIL");
}


// void result, changes margin to 'margin' -- indended to remove default margin of 8px
function MadxBridge_AdjustMargin(margin)
{
  document.getElementsByTagName('body')[0].style.margin = margin;
}

// void result, disables touch events in html, indended to prevent scrolling
function MadxBridge_DisableTouch()
{
  document.addEventListener('touchmove', function(e) {e.preventDefault();}, true);
}


//javascript in calling html can define this and create new rules
//function MadxBridge_OverrideShouldShowAd()
//{
//return true;
//}

// MadxBridge_ShouldShowAd - simple definition, if there's an image that is bigger than 1x1
// then we treat this as a valid ad
// returns MadxBridge JSON object {success="OK|FAIL"}
function MadxBridge_ShouldShowAd()
{
  if (typeof MadxBridge_OverrideShouldShowAd == "function")
    return MadxBridge_ReturnResult(MadxBridge_OverrideShouldShowAd());
  
  var images = window.document.getElementsByTagName('img');
  for (var i = 0; i < images.length; ++i)
  {
  	var width = images[i].naturalWidth;
  	var height = images[i].naturalHeight;
  	
  	if (width > 1 || height > 1)
	  	return MadxBridge_ReturnResult(true);
  }
  
  return MadxBridge_ReturnResult(false);
}

// returns MadxBridge JSON object {success="OK|FAIL", data=[{src,width,height}*]}

function MadxBridge_EnumerateImages()
{
  var result = {};
  var images = window.document.getElementsByTagName('img');
  result.images = new Array();
  for (var i = 0; i < images.length; ++i)
  {
    var imageData = {};
    imageData.src = images[i].src;
    imageData.width = images[i].naturalWidth;
    imageData.height = images[i].naturalHeight;
    
  	result.images[i] = imageData;
  }
  
  return MadxBridge_ReturnResultWithData(true, result);
}

// really simple function returns a string value if this script parses correctly
function MadxBridge_Loaded()
{
  var publicMethods = [
                       "MadxBridge_AdjustMargin",
                       "MadxBridge_DisableTouch",
                       "MadxBridge_ShouldShowAd",
                       "MadxBridge_EnumerateImages",
                       "MadxBridge_Test"
                       ];
  
  return MadxBridge_ReturnResultWithData(true, publicMethods);
}

