function findAndReplace(searchText, replacement, searchNode) 
{
	if (!searchText || typeof replacement === 'undefined') {
		// Throw error here if you want...
		return;
	}
	var regex = typeof searchText === 'string' ?
				new RegExp(searchText, 'g') : searchText,
		childNodes = (searchNode || document.body).childNodes,
		cnLength = childNodes.length,
		excludes = 'html,head,style,title,link,meta,script,object,iframe';
	while (cnLength--) {
		var currentNode = childNodes[cnLength];
		if (currentNode.nodeType === 1 &&
			(excludes + ',').indexOf(currentNode.nodeName.toLowerCase() + ',') === -1) {
			arguments.callee(searchText, replacement, currentNode);
		}
		if (currentNode.nodeType !== 3 || !regex.test(currentNode.data) ) {
			continue;
		}
		var parent = currentNode.parentNode,
			frag = (function(){
				var html = currentNode.data.replace(regex, replacement),
					wrap = document.createElement('div'),
					frag = document.createDocumentFragment();
				wrap.innerHTML = html;
				while (wrap.firstChild) {
					frag.appendChild(wrap.firstChild);
				}
				return frag;
			})();
		parent.insertBefore(frag, currentNode);
		parent.removeChild(currentNode);
	}
}
function searchNodeTree(searchNode, searchText, searchNodeName)
{
	var foundNode = null;
	
	try
	{
		var childNodes = (searchNode || document.body).childNodes;
		var childIndex = 0;
		for (childIndex=0; childIndex < childNodes.length; childIndex++)
		{
			var currentNode = childNodes[childIndex];
			var parentNode = currentNode.parentNode;
			
			if (currentNode.nodeType == 3 && parentNode && parentNode.nodeName.toLowerCase() == searchNodeName)
			{
				var regex = new RegExp(searchText, 'i');
				
				if (regex.test(currentNode.data) == true)
				{
					foundNode = parentNode;
					break;
				}
			}
			else
			{						
				var theNode = searchNodeTree(currentNode, searchText, searchNodeName);
				if (theNode)
				{
					foundNode = theNode;
					break;
				}
			}
		}
	}
	catch (e)
	{
		console.log( "dumpNodeTree failed" + e );
	}
	
	return foundNode;
}
function removePreviousSiblings(node, nodeHTML, count)
{
	try
	{
		if (node)
		{
			var regex = new RegExp(nodeHTML);
			var theParent = node.parentNode;
			var removeCount = 0;
		
			var theSibling = node.previousSibling;
			while (theSibling)
			{
				console.log( "remove?? ["+theSibling.outerHTML+"] {"+nodeHTML+"}" );
			
				if (regex.test(theSibling.outerHTML) == true)
				{
					var thePreviousSibling = theSibling.previousSibling;
				
					if (removeCount < count)
					{
						theParent.removeChild(theSibling);
						removeCount = removeCount + 1;
						console.log( "     removed!" );
					}
					else
					{
						break;
					}
					theSibling = thePreviousSibling;
				}
				else
				{
					break;
				}
			}
		}
	}
	catch (e)
	{
		console.log( "removePreviousSiblings failed" + e );
	}
}
function removeChildNodes(parent)
{
	var theChildren = [];
	
	try
	{
		if (parent)
		{
			var index=0;
			while (parent.firstChild())
			{
				var theChild = parent.firstChild();
				theChildren[index] = theChild;
				index += 1;
				parent.removeChild(theChild);
			}
		}
	}
	catch (e)
	{
		console.log( "removeChildNodes failed" + e );
	}
	
	return theChildren;
}
function showExternalPhotoGallery()
{
}
function showInternalPhotoGallery()
{
}
function addOrnaments()
{
	try
	{
		if (gArticleOrnamentVisibility == 'yes')
		{
			var articleContentDiv = document.getElementById('article_content_div');
			if (articleContentDiv)
			{
				var articleContentDivImage = new Image();
				articleContentDivImage.onload = function() {
					var articleContentDiv = document.getElementById('article_content_div');
					articleContentDiv.style.background = "url("+gArticleBottomEdgeImageUrl+") repeat-x bottom";
					if (window.devicePixelRatio > 1)
						articleContentDiv.style.backgroundSize = articleContentDivImage.width/2 + "px " + articleContentDivImage.height/2 + "px";
				}
				articleContentDivImage.src = gArticleBottomEdgeImageUrl;
			}
	
			var articleRelatedSectionDiv = document.getElementById('related_articles_div');
			if (articleRelatedSectionDiv)
			{
				var articleRelatedSectionDivImage = new Image();
				articleRelatedSectionDivImage.onload = function() {
					var articleRelatedSectionDiv = document.getElementById('related_articles_div');
					articleRelatedSectionDiv.style.background = "url("+gArticleRelatedSectionBackgroundImageUrl+") repeat";
					if (window.devicePixelRatio > 1)
						articleRelatedSectionDiv.style.backgroundSize = articleRelatedSectionDivImage.width/2 + "px " + articleRelatedSectionDivImage.height/2 + "px";
				}
				articleRelatedSectionDivImage.src = gArticleRelatedSectionBackgroundImageUrl;
			}
	
			var articleRelatedSectionShadow = document.getElementById('related_articles_shadow');
			if (articleRelatedSectionShadow)
			{
				var articleRelatedSectionShadowImage = new Image();
				articleRelatedSectionShadowImage.onload = function() {
					var articleRelatedSectionShadow = document.getElementById('related_articles_shadow');
					articleRelatedSectionShadow.style.background = "url("+gArticleRelatedSectionShadowImageUrl+") repeat-x bottom";
					if (window.devicePixelRatio > 1)
						articleRelatedSectionShadow.style.backgroundSize = articleRelatedSectionShadowImage.width/2 + "px " + articleRelatedSectionShadowImage.height/2 + "px";
				}
				articleRelatedSectionShadowImage.src = gArticleRelatedSectionShadowImageUrl;					
			}
		}
	}
	catch (e)
	{
		console.log( "addOrnaments failed" + e );
	}
}
function insertMyStreamButton()
{
	try
	{
		var myStreamImage = document.getElementById('my_engadget_stream_img');
		if (!myStreamImage)
		{
			var myStreamDiv = document.getElementById('my_engadget_stream_div');
			if (myStreamDiv)
			{
				var anchorNode = document.createElement('A');
				anchorNode.setAttribute('href', 'internal://show_mystream');
		
				var newImage = new Image();
		
				newImage.onload = function() {
					if (window.devicePixelRatio > 1)
						newImage.width = newImage.width / 2.0;
			
					anchorNode.appendChild(newImage);
				}
		
				newImage.id = "my_engadget_stream_img";
				newImage.src = "url("+gArticleMyEngadgetStreamImageUrl+")";
		
				myStreamDiv.appendChild(anchorNode);
			}
		}
	}
	catch (e)
	{
		console.log( "insertMyStreamButton failed" + e );
	}
}
function fixPRbox()
{
	try
	{
		var prImage = document.getElementsByClassName('show_full_pr_text_img')[0];
		if (!prImage)
		{
			var prBox = document.getElementsByClassName('pr_box')[0];
			var prBoxButton = document.getElementsByClassName('pr_box_button')[0];
			var prText = document.getElementsByClassName('pr_text')[0];
		
			if (!prBox)
			{
				prBox = document.getElementById('pr_box');
			}
			if (!prBoxButton)
			{
				prBoxButton = document.getElementById('pr_box_button');
			}
			if (!prText)
			{
				prText = document.getElementById('pr_text');
			}
	
			if (prBox && prBoxButton && prText)
			{
				prText.style.display = 'none';
		
				// insert show full pr text button
				var newImage = new Image();
				newImage.bkWidthAdjusted = 0;
		
				newImage.onload = function() {
					if (newImage.bkWidthAdjusted == 0)
					{
						if (window.devicePixelRatio > 1)
							newImage.width = newImage.width / 2.0;
						newImage.bkWidthAdjusted = 1;
					}
			
					prBoxButton.style.display = 'none';
					prBox.insertBefore(newImage, prBoxButton);
				}
				newImage.onclick = function() {
					var prText = document.getElementsByClassName('pr_text')[0];
				
					if (!prText)
					{
						prText = document.getElementById('pr_text');
					}
				
					if (prText.style.display == 'none')
					{
						newImage.src = gArticleHideFullPRImageUrl;
						prText.style.display = 'block';
					}
					else
					{
						newImage.src = gArticleShowFullPRImageUrl;
						prText.style.display = 'none';
					}
				}
		
				newImage.src = gArticleShowFullPRImageUrl;
				newImage.className = 'show_full_pr_text_img';
			}
		}
	}
	catch (e)
	{
		console.log( "fixPRbox failed" + e );
	}
}
function fixViaSection()
{
	try
	{
		var theViaStrongNode = searchNodeTree(null, "Via:", "strong");
		if (theViaStrongNode)
		{
			var theViaPNode = theViaStrongNode.parentNode;
			if (theViaPNode.nodeName.toLowerCase() == "p")
			{
				var articleViaDiv = document.getElementById('article_via_div');
				if (articleViaDiv)
				{					
					var theParent = theViaPNode.parentNode;
				
					if (theParent.id != 'article_via_div')
					{	
						// remove 2 <br> immediately preceding this node, if they exist
						removePreviousSiblings(theViaPNode, "<br>", 2);
					
						// remove the p
						theParent.removeChild(theViaPNode);
					
						// append the p
						articleViaDiv.appendChild(theViaPNode);
				
						articleViaDiv.style.display = "block";
					}
				}	
			}
		}
	}
	catch (e)
	{
		console.log( "fixViaSection failed" + e );
	}
}
function fixSourceSection()
{
	try
	{
		var theSourceStrongNode = searchNodeTree(null, "Source:", "strong");
		if (theSourceStrongNode)
		{
			var theSourcePNode = theSourceStrongNode.parentNode;
			if (theSourcePNode.nodeName.toLowerCase() == "p")
			{
				var articleSourceDiv = document.getElementById('article_source_div');
				if (articleSourceDiv)
				{					
					var theParent = theSourcePNode.parentNode;
			
					if (theParent.id != 'article_source_div')
					{
						// remove 2 <br> immediately preceding this node, if they exist
						removePreviousSiblings(theSourcePNode, "<br>", 2);
					
						// remove the p
						theParent.removeChild(theSourcePNode);
					
						// append the p
						articleSourceDiv.appendChild(theSourcePNode);
				
						articleSourceDiv.style.display = "block";
					}
				}
			}
		}
	}
	catch (e)
	{
		console.log( "fixSourceSection failed" + e );
	}
}
function fixCommentsAnchor() 
{
	try
	{
		var theCommentsAnchorNode = searchNodeTree(null, "Comments", "a");
		if (theCommentsAnchorNode)
		{
			var theCommentsStrongNode = theCommentsAnchorNode.parentNode;
			if (theCommentsStrongNode.nodeName.toLowerCase() == "strong")
			{
				var theCommentsPNode = theCommentsStrongNode.parentNode;
				if (theCommentsPNode.nodeName.toLowerCase() == "p")
				{
					theCommentsPNode.parentNode.removeChild(theCommentsPNode);
				}
			}
		}
	}
	catch (e)
	{
		console.log( "fixCommentsAnchor failed" + e );
	}
}
function addTagsList()
{
	try
	{
		var tagsListSpan = document.getElementById('article_tags_list_span');
	
		if (tagsListSpan && tagsListSpan.childElementCount == 0)
		{
			var articleTagsArray = gArticleTagsArray;
					
			for (i=0; i < articleTagsArray.length; i++)
			{
				var newAnchor = document.createElement('A');
				newAnchor.appendChild(document.createTextNode(articleTagsArray[i]));
				newAnchor.setAttribute('href', 'internal://show_tag_feed?'+articleTagsArray[i]);
				newAnchor.className = "article_tags_list_item_anchor";
				
				tagsListSpan.appendChild(newAnchor);
				if (i+1 < articleTagsArray.length)
					tagsListSpan.appendChild(document.createTextNode(', '));
			}
		}
	}
	catch (e)
	{
		console.log( "addTagsList failed" + e );
	}
}
function addTopicsList()
{
	try
	{
		var topicsListSpan = document.getElementById('article_topics_list_span');
	
		if (topicsListSpan && topicsListSpan.childElementCount == 0)
		{
			var articleTopicsArray = gArticleTopicsArray;
						
			for (i=0; i < articleTopicsArray.length; i++)
			{
				var newAnchor = document.createElement('A');
				newAnchor.appendChild(document.createTextNode(articleTopicsArray[i]));
				newAnchor.setAttribute('href', 'internal://show_topic_feed?'+articleTopicsArray[i]);
				newAnchor.className = "article_topics_list_item_anchor";
				
				topicsListSpan.appendChild(newAnchor);
				if (i+1 < articleTopicsArray.length)
					topicsListSpan.appendChild(document.createTextNode(', '));
			}
		}
	}
	catch (e)
	{
		console.log( "addTopicsList failed" + e );
	}
}
function appendCustomNode(parent, nodeName, className, styleMap, href, src, text)
{
	try
	{
		if (parent)
		{
			var newNode = null;
		
			if (nodeName.toLowerCase() == "img")
				newNode = new Image();
			else
				newNode = document.createElement(nodeName);
			if (newNode)
			{
				if (className)
					newNode.className = className;
				if (styleMap)
				{
					if (styleMap['width'])
						newNode.style.width = styleMap['width'];
					if (styleMap['height'])
						newNode.style.height = styleMap['height'];
					if (styleMap['vertical-align'])
						newNode.style.verticalAlign = styleMap['vertical-align'];
				}
				if (href)
					newNode.setAttribute('href', href);
				if (text)
				{
					var newText = document.createTextNode(text);
					newNode.appendChild(newText);
				}
				if (src && nodeName.toLowerCase() == "img")
				{
					newNode.onload = function() {
						if (window.devicePixelRatio > 1)
							newNode.width = newNode.width / 2.0;
					}
					newNode.src = src;
					parent.appendChild(newNode);
				}
				else
				{
					parent.appendChild(newNode);
				}
			
				return newNode;
			}
		}
		return null;
	}
	catch (e)
	{
		console.log( "appendCustomNode failed" + e );
	}
}
function applyBackgroundImageToNodeAndPositionImage( node, imageSrc )
{
	try
	{
		if (node && imageSrc)
		{
			var nodeId = node.id;
			
			var theImage = new Image();
						
			theImage.onload = function() {
				var theNode = document.getElementById(nodeId);
				if (theNode)
				{
					theNode.style.backgroundImage = "url("+imageSrc+")";
					theNode.style.backgroundPosition = "center top";
					theNode.style.backgroundRepeat = "no-repeat";
					if (window.devicePixelRatio > 1)
						theNode.style.backgroundSize = theImage.width/2 + "px " + theImage.height/2 + "px";
				}
			}
			theImage.src = imageSrc;
		}
	}
	catch (e)
	{
		console.log( "applyBackgroundImageToNode failed" + e );
	}
}
function applyBackgroundImageToNode( node, imageSrc )
{
	try
	{
		if (node && imageSrc)
		{
			var nodeId = node.id;
			
			var theImage = new Image();
						
			theImage.onload = function() {
				var theNode = document.getElementById(nodeId);
				if (theNode)
				{
					theNode.style.backgroundImage = "url("+imageSrc+")";
					if (window.devicePixelRatio > 1)
						theNode.style.backgroundSize = theImage.width/2 + "px " + theImage.height/2 + "px";
				}
			}
			theImage.src = imageSrc;
		}
	}
	catch (e)
	{
		console.log( "applyBackgroundImageToNode failed" + e );
	}
}
function fillRelatedSection( relatedArticles )
{
	try
	{
		var result = "";
		var relatedArticlesUL = document.getElementById('related_articles_list_ul');
	
		if (relatedArticlesUL)
		{				
			var newRelatedArticlesUL = document.createElement('UL');
			newRelatedArticlesUL.className = "related_articles_boxes";
			newRelatedArticlesUL.id = "related_articles_list_ul";
		
			relatedArticlesUL.parentNode.replaceChild(newRelatedArticlesUL, relatedArticlesUL);
			
			if (relatedArticles.length > 0)
			{				
				for (i=0; i < relatedArticles.length; i++)
				{
					var articleInfo = relatedArticles[i];
				
					// (parent, nodeName, className, style, href, src, text)
					var node1 = appendCustomNode(newRelatedArticlesUL, "LI", "related_articles_box", null, null, null, null);
					var node2 = appendCustomNode(node1, "DIV", "related_articles_box_div", null, null, null, null);
					var node3 = appendCustomNode(node2, "DIV", "related_articles_box_div2", null, null, null, null);
					var node4 = appendCustomNode(node3, "A", "related_articles_box_anchor", null, articleInfo["link"], null, null);
					var node5 = appendCustomNode(node4, "TABLE", null, {"width":"100%","height":"100%"}, null, null, null);
					var node6 = appendCustomNode(node5, "TR", null, null, null, null, null);
					var node7 = appendCustomNode(node6, "TD", null, {"width":"80px"}, null, null, null);
					var node8 = appendCustomNode(node7, "TABLE", null, {"width":"100%","height":"100%"}, null, null, null);
					var node9 = appendCustomNode(node8, "TR", null, {"height":"60px"}, null, null, null);
					var node10 = appendCustomNode(node9, "TD", null, null, null, null, null);
					var node11 = appendCustomNode(node10, "DIV", "related_articles_box_thumbnail_div", null, null, null, null);
					var node12 = appendCustomNode(node11, "IMG", "related_articles_box_thumbnail_image", null, null, articleInfo["thumbnail"], null);
					var node13 = appendCustomNode(node8, "TR", null, null, null, null, null);
					var node14 = appendCustomNode(node13, "TD", null, null, null, null, null);
					var node15 = appendCustomNode(node14, "SPAN", "related_articles_box_commenticon_span", null, null, null, null);
					var node16 = appendCustomNode(node15, "IMG", "related_articles_box_commenticon_image", null, null, articleInfo["commenticon"], null);
					var node17 = appendCustomNode(node14, "SPAN", "related_articles_box_commentcount_span", null, null, null, articleInfo["commentcount"]);
					var node18 = appendCustomNode(node6, "TD", null, null, null, null, null);
					var node19 = appendCustomNode(node18, "TABLE", null, {"width":"100%","height":"100%"}, null, null, null);
					var node20 = appendCustomNode(node19, "TR", null, null, null, null, null);
					var node21 = appendCustomNode(node20, "TD", null, {"vertical-align": "top"}, null, null, null);
					var node22 = appendCustomNode(node21, "DIV", "related_articles_box_title_div", null, null, null, articleInfo["title"]);
					var node23 = appendCustomNode(node21, "DIV", "related_articles_box_subtitle_div", null, null, null, articleInfo["subtitle"]);
																
					result = result + ", newListItem";
				}
			
				var boxDivNodes = document.getElementsByClassName("related_articles_box_div");
			
				for (i=0; i < boxDivNodes.length; i++)
				{
					var theBoxDiv = boxDivNodes[i];
					if (theBoxDiv)
					{
						theBoxDiv.id = "related_articles_box_div_" + (i+1);
						
						applyBackgroundImageToNodeAndPositionImage(theBoxDiv, gArticleRelatedBackgroundImageUrl);
					}
				}
		
				showDiv(document.getElementById('related_articles_div'), 'yes');
			}
			else
			{
				result = "relatedArticles empty";
				showDiv(document.getElementById('related_articles_div'), 'no');
			}
		}
		else
		{
			result = "relatedArticlesUL not found";
			showDiv(document.getElementById('related_articles_div'), 'no');
		}
	
		return result;
	}
	catch (e)
	{
		console.log( "fillRelatedSection failed" + e );
	}
}
function fixPhotoGalleryButtons()
{
	try
	{
		var oldDeepLinkButtons = document.getElementsByClassName("deepLinkGalleryButton");
		if (oldDeepLinkButtons.length)
		{
			for (i=0; i < oldDeepLinkButtons.length; i++)
			{
				var oldDeepLinkButton = oldDeepLinkButtons[i];
				
				applyBackgroundImageToNode(oldDeepLinkButton, gArticlePhotoGalleryButtonImageUrl);
			}
		}
		else
		{
			console.log( "fixPhotoGalleryButtons - no gallery buttons" );
		}
	}
	catch (e)
	{
		console.log( "fixPhotoGalleryButtons failed" + e );
	}
}
function replacePhotoGalleryButton( galleryInfo )
{	
	try
	{
		var result = "";
		if (galleryInfo)
		{
			var galleryID = galleryInfo["galleryid"];
			if (galleryID)
			{
				var oldDeepLinkButtons = document.getElementsByClassName("deepLinkGalleryButton");
				if (oldDeepLinkButtons.length)
				{
					for (i=0; i < oldDeepLinkButtons.length; i++)
					{
						var oldDeepLinkButton = oldDeepLinkButtons[i];
						if (oldDeepLinkButton.id == "deepLinkGalleryButton_" + galleryID)
						{
							var newGalleryDiv = document.createElement('DIV');
							newGalleryDiv.className = "gallery_div";
							newGalleryDiv.id = "gallery_div_" + galleryID;
							
							applyBackgroundImageToNode( newGalleryDiv, gArticlePhotoGalleryBackgroundImageUrl );
												
							var newGalleryTitle = document.createElement('H3');
							newGalleryTitle.className = "gallery_title";
							newGalleryTitle.innerHTML = galleryInfo["title"];
						
							var newGalleryList = document.createElement('UL');
							newGalleryList.className = "gallery_boxes";
						
							newGalleryDiv.appendChild(newGalleryTitle);
							newGalleryDiv.appendChild(newGalleryList);
					
							var galleryPhotoInfos = galleryInfo["photoinfo_list"];
							if (galleryPhotoInfos.length)
							{
								for (j=0; j < galleryPhotoInfos.length; j++)
								{
									var photoInfo = galleryPhotoInfos[j];
								
									var newPhotoListItem = document.createElement('LI');
									newPhotoListItem.className = "gallery_box";
							
									var newPhotoAnchor = document.createElement('A');
									newPhotoAnchor.className = "gallery_link";
									newPhotoAnchor.href = photoInfo["photo_action_url"];
								
									var newPhotoImage = document.createElement('IMG');
									newPhotoImage.className = "gallery_image";
									newPhotoImage.src = photoInfo["photo_image_url"];
								
									newPhotoAnchor.appendChild(newPhotoImage);
									newPhotoListItem.appendChild(newPhotoAnchor);
									newGalleryList.appendChild(newPhotoListItem);
								}
							}
						
							var clearDiv = document.createElement('DIV');
							clearDiv.className = "clear";
							
							newGalleryDiv.appendChild(clearDiv);
						
							oldDeepLinkButton.parentNode.replaceChild(newGalleryDiv, oldDeepLinkButton);
						}
					}
				}
				else
				{
					result = "no deepLinkGalleryButton nodes";
				}
			}
			else
			{
				result = "no galleryid in info";
			}
		}
		else
		{
			result = "no galleryInfo";
		}
	
		return result;
	}
	catch (e)
	{
		console.log( "replacePhotoGalleryButton failed" + e );
	}
}
function filterBadObjects ()
{
	try
	{
		// look at object nodes
		{
			var objectNodes = document.getElementsByTagName('object');
			if (objectNodes.length)
			{
				for (i=0; i < objectNodes.length; i++)

				{
					var objectNode = objectNodes[i];
				
					var isAudio = false;
					var isVideo = false;
					var mediaSrc = null;
				
					var objectType = objectNode.getAttribute("type");						
					if (objectType.toLowerCase() == "application/x-shockwave-flash")
					{																					
						for (i=0; i < objectNode.childNodes.length; i++)
						{
							var aParam = objectNode.childNodes[i];					
							var paramNodeName = aParam.nodeName;
							var paramName = aParam.getAttribute("name");
														
							if (paramNodeName.toLowerCase() == "param" && paramName.toLowerCase() == "flashvars")
							{
								var paramValue = aParam.getAttribute("value");
								var paramValueParts = paramValue.split("=",2);
																
								mediaSrc = paramValueParts[1];
								var mediaSrcParts = mediaSrc.split(".");
																
								var mediaExt = mediaSrcParts[mediaSrcParts.length-1];
															
								if (mediaExt.toLowerCase() == "mp3" || mediaExt.toLowerCase() == "aac")
									isAudio = true;
								else if (mediaExt.toLowerCase() == "mp4" || mediaExt.toLowerCase() == "mov")
									isVideo = true;
							
								break;
							}
						}
					}
					else
					{
					}
			
					if (mediaSrc)
					{
						if (isAudio)
						{
							var newAudioTag = new Audio();
							newAudioTag.controls = "controls";
							newAudioTag.src = mediaSrc;
							newAudioTag.autoplay = false;
						
							objectNode.parentNode.replaceChild(newAudioTag, objectNode);
						}
						else if (isVideo)
						{
							var newVideoTag = new Video();
							newVideoTag.controls = "controls";
							newVideoTag.src = mediaSrc;
						
							objectNode.parentNode.replaceChild(newVideoTag, objectNode);
						}
					}
				}
			}
		}
	}
	catch (e)
	{
		console.log( "filterBadObjects failed" + e );
	}
}
function fixAudioEnclosure()
{
	if (gArticleAudioEnclosureSourceUrl.length)
	{
		var audioEnclosureDiv = document.getElementById('audio_enclosure_div');
		if (audioEnclosureDiv)
		{
			if (audioEnclosureDiv.childElementCount == 0)
			{
				var newAudioTag = new Audio();
				newAudioTag.controls = "controls";
				newAudioTag.src = gArticleAudioEnclosureSourceUrl;
				newAudioTag.autoplay = false;
						
				audioEnclosureDiv.appendChild(newAudioTag);
			}
		}
	}
}
function fixVideoEnclosure()
{
	if (gArticleVideoEnclosureSourceUrl.length)
	{
		var videoEnclosureDiv = document.getElementById('video_enclosure_div');
		if (videoEnclosureDiv)
		{
			if (videoEnclosureDiv.childElementCount == 0)
			{
				var newVideoTag = new Video();
				newVideoTag.controls = "controls";
				newVideoTag.src = gArticleVideoEnclosureSourceUrl;
						
				videoEnclosureDiv.appendChild(newVideoTag);
			}
		}
	}
}
function preprocessDom()
{
	try
	{
		addOrnaments();
		//insertMyStreamButton();
		fixPhotoGalleryButtons();
		fixPRbox();
		filterBadObjects();
		fixViaSection();
		fixSourceSection();
		fixCommentsAnchor();
		fixAudioEnclosure();
		fixVideoEnclosure();
		insertArticleContent();
		//fixStylesheets();
	}
	catch (e)
	{
		console.log( "preprocessDom failed" + e );
	}
}
function showDiv( element, flag )
{
	try
	{
		if (element)
		{
			if (flag == 'no')
			{
				element.style.display = 'none';
			}
			else
			{
				element.style.display = 'block';
			}
		}
	}
	catch (e)
	{
		console.log( "showDiv failed" + e );
	}
}
/*
function photoGalleryButtonCssRule()
{
	for (i=0; i < document.styleSheets.length; i++)
	{
		var stylesheet = document.styleSheets[i];
		for (j=0; j < stylesheet.cssRules.length; j++)
		{
			var cssRule = stylesheet.cssRules[j];
		
			if (cssRule.selectorText == '.deepLinkGalleryButton')
			{
				return cssRule;
			}
		}
	}
	
	return;
}
function fixStylesheets()
{
	if (gArticlePhotoGalleryButtonImageUrl.length > 0)
	{
		var cssRule = photoGalleryButtonCssRule();
		
		if (cssRule)
		{
			if (cssRule.selectorText == '.deepLinkGalleryButton')
			{
				var newGalleryButtonImage = new Image();
				newGalleryButtonImage.onload = function() {
					var cssRule = photoGalleryButtonCssRule();
					if (cssRule)
					{
						cssRule.style.backgroundImage = "url("+gArticlePhotoGalleryButtonImageUrl+")";
						if (window.devicePixelRatio > 1)
							cssRule.style.backgroundSize = newGalleryButtonImage.width/2 + "px " + newGalleryButtonImage.height/2 + "px";
					}
				}
				newGalleryButtonImage.src = gArticlePhotoGalleryButtonImageUrl;
			}
		}
	}
}
*/
function processOptionalElements()
{
	try
	{
		showDiv(document.getElementById('lead_image_div'), gArticleLeadImageVisibility);
		showDiv(document.getElementById('lead_title_div'), gArticleLeadTitleVisibility);
		showDiv(document.getElementById('lead_source_div'), gArticleLeadSourceVisibility);
		showDiv(document.getElementById('before_article_body_div'), gArticleBeforeBodyVisiblity);
		showDiv(document.getElementById('my_engadget_stream_div'), gArticleMyEngadgetStreamVisibility);
		showDiv(document.getElementById('ke_ninja'), gArticleBodyVisibility);
		showDiv(document.getElementById('after_article_body_div'), gArticleAfterBodyVisibility);
		showDiv(document.getElementById('article_tags_div'), gArticleTagsVisibility);
		showDiv(document.getElementById('article_topics_div'), gArticleTopicsVisibility);			
		showDiv(document.getElementById('article_content_div'), 'yes');
		showDiv(document.getElementById('audio_enclosure_div'), gArticleAudioEnclosureVisibility);
		showDiv(document.getElementById('video_enclosure_div'), gArticleVideoEnclosureVisibility);
		showDiv(document.getElementById('category'), 'no');
		showDiv(document.getElementById('tags'), 'no');

		showDiv(document.getElementById('related_articles_div'), gRelatedArticleVisibility);
	}
	catch (e)
	{
		console.log( "processOptionalElements failed" + e );
	}
}
function configureDOM()
{
	try
	{
		preprocessDom();
		processOptionalElements();
	}
	catch (e)
	{
		console.log( "configureDOM failed" + e );
	}
	
	document.body.style.display = 'block';
}
function documentOnLoad()
{
	var t = setTimeout( configureDOM(), 1 );
}

window.onload = documentOnLoad;